#include "verbimorfo.hh"
#include "nominimorfo.hh"

#include <string>
#include <cstdio>
#include <vector>

//#define _GNU_SOURCE                           
#include <getopt.h>

using std::string;
using std::printf;
using std::fprintf;

bool debugflag = false;

int main(int argc, char *const *argv)
{
    string pers = "pas";
    string sija = "nom";
    bool monikko = false;
    int verbose = 0;
    
    bool errors = false;
    bool sanoja = false;
    for(;;)
    {
        static struct option long_options[] =
        {
            {"help",     0,  0,'h'},
            {"version",  0,  0,'V'},
            {"pers",     1,  0,'p'},
            {"moni",     0,  0,'l'},
            {"sija",     1,  0,'j'},
            {"verbose",  0,  0,'v'},
            {"debug",    0,  0,'d'}
        };
        
        switch(getopt_long(argc, argv, "-hVp:lj:vd", long_options, NULL))
        {
            case 'V': printf("%s\n", VERSION); return 0;
            case 'p': pers = optarg; break;
            case 'j': sija = optarg; break;
            case 'l': monikko = true; break;
            case 'v': if(true)++verbose;else --verbose; break;
            case 'd': debugflag = true; break;
            case 'h':
            Help:
                printf(
                    "formodemo v"VERSION" - Copyright (C) 1992,2005 Bisqwit (http://iki.fi/bisqwit/)\n"
                    "Kiitokset Juha Niemiselle avusta.\n"
                    "\n"
                    "Kytt: %s [<option> [<...>]] <sana> [<...>]\n"
                    "\n"
                    "Valitsimet:\n", argv[0]);
                printf(
                    "  --help, -h             Tm ohje\n"
                    "  --version, -V          Tulostaa versiotiedon\n"
                    "  --pers, -p<persoona>   Valitse omistusliite (yks1,yks2,yks3,mon1,mon2,mon3,pass)\n"
                    "  --moni, -l             Valitse monikko\n"
                    "  --sija, -j<sija>       Valitse sijamuoto (nom,gen,ak,es,pa,tr,ine,el,il,ade,abl,al,abe,kom,ins)\n"
                    "  --verbose, -v          Lis tulostettavan tiedon mr.\n"
                    "  --debug, -d            Debug.\n"
                     );
                printf(
                    "\nHuom: Laita taivutettavat sanat komentorivin loppuun.\n"
                    "Uudet valitsimet vaikuttavat vain sit seuraaviin sanoihin.\n");
                return 0;
            case 1:
            {
                string word = optarg;
                
                string result;
                
                sijamuoto j;
                persoona p;
                
/* The following code has been generated by hashes from hashes.txt */
#include "noun-main-hash.inc"

                sanoja = true;
                
                string sana = word;
                word = NominiTaivutus(word, j, monikko, p);
                
                std::vector<string> defs;

                switch(j)
                {
                    case NOMINATIIVI:      defs.push_back("Nominative"); break;
                    case GENETIIVI:        defs.push_back("Genetive"); break;
                    case AKKUSATIIVI:      defs.push_back("Accusative"); break;
                    case ESSIIVI:          defs.push_back("Essive"); break;
                    case PARTITIIVI:       defs.push_back("Partitive"); break;
                    case TRANSLATIIVI:     defs.push_back("Translative"); break;
                    case INESSIIVI:        defs.push_back("Inessive"); break;
                    case ELATIIVI:         defs.push_back("Elative"); break;
                    case ILLATIIVI:        defs.push_back("Illative"); break;
                    case ADESSIIVI:        defs.push_back("Adessive"); break;
                    case ABLATIIVI:        defs.push_back("Ablative"); break;
                    case ALLATIIVI:        defs.push_back("Allative"); break;
                    case ABESSIIVI:        defs.push_back("Abessive"); break;
                    case KOMITATIIVI:      defs.push_back("Comitative"); break;
                    case INSTRUKTIIVI:     defs.push_back("Instructive"); break;
                    case SUPERESSIIVI:     defs.push_back("Superessive"); break;
                    case DELATIIVI:        defs.push_back("Delative"); break;
                    case SUBLATIIVI:       defs.push_back("Sublative"); break;
                    case LATIIVI:          defs.push_back("Lative"); break;
                    case TEMPORAALI:       defs.push_back("Temporal"); break;
                    case KAUSATIIVI:       defs.push_back("Causative"); break;
                    case MULTIPLIKATIIVI:  defs.push_back("Multiplicative"); break;
                    case DISTRIBUTIIVI:    defs.push_back("Distributive"); break;
                    case TEMPDISTRIBUTIIVI:defs.push_back("Temporal distributive"); break;
                    case PROLATIIVI:       defs.push_back("Prolative"); break;
                    case SITUATIIVI:       defs.push_back("Situative"); break;
                    case OPPOSITIIVI:      defs.push_back("Oppositive"); break;
                }

                if(monikko)
                    defs.push_back("Plural");

                switch(p)
                {
                    case YKS1: defs.push_back("Singular 1st"); break;
                    case YKS2: defs.push_back("Singular 2nd"); break;
                    case YKS3: defs.push_back("Singular 3rd"); break;
                    case MON1: defs.push_back("Plural 1st"); break;
                    case MON2: defs.push_back("Plural 2nd"); break;
                    case MON3: defs.push_back("Plural 3rd"); break;
                    case PASSIIVI: /*ei omistusliitett*/ break;
                }

                for(unsigned a=0; a<defs.size(); ++a)
                    printf("> %s ", defs[a].c_str());
                printf("\n");
                printf("%s\n", word.c_str());
                break;
            }
            case -1: goto done_args;
            default:
                errors=true;
        }
    }
done_args:
    if(!errors && !sanoja)
    {
        fprintf(stderr, "Sanaton!\n");
        goto Help;
    }
    return 0;
}
